#include "stdafx.h"
#include "ModelViewerRenderer.h"


CModelViewerRenderer::CModelViewerRenderer() :
	m_bRotation(true),
	m_bPan(true),
	m_bZoom(true),
	m_bRenderPoint(true),
	m_bRenderLine(true),
	m_bRenderFace(true),
	m_bPickPoint(true),
	m_bPickLine(true),
	m_bPickFace(true)
{
	//MakeArray();
	memset( m_auiVboID, 0x00, 3 * sizeof( unsigned int ) );
}


CModelViewerRenderer::~CModelViewerRenderer()
{
	//DestroyArray();
}

bool CModelViewerRenderer::DoTracking( POINT point )
{
	if( (TM_ROTATION == m_eTrackingMode && !m_bRotation)
	 || (TM_PAN == m_eTrackingMode && !m_bPan)
	 || (TM_ZOOM == m_eTrackingMode && !m_bZoom) )
	{       // ȃ}EXΉ
		return false;
	}

	// eNX̊֐̌Ăяo
	return COpenGLRendererPick::DoTracking( point );
}

void CModelViewerRenderer::RenderModel( ERENDERMODE eRenderMode )
{
	if( 0 == m_model.m_vVertex.size() )
	{
		return;
	}

	if( 0 == m_model.m_vIndexedTriangle.size() )
	{
		return;
	}

	unsigned int uiIndexTriangle;
	unsigned int uiIndexLine;
	unsigned int uiIndexPoint;
	unsigned int ui3;

	glPushAttrib( GL_ALL_ATTRIB_BITS );	// Agr[gAł悤ɁAǉ

	// _z̗L
	glEnableClientState( GL_VERTEX_ARRAY );

	// _z̎w
	glBindBuffer( GL_ARRAY_BUFFER, m_model.GetTriangleVertexVboID() );	// VBO
	//glVertexPointer( 3, GL_FLOAT, 0, m_model.m_afTriangleVertex );
	glVertexPointer( 3, GL_FLOAT, 0, (float*)0 );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉

	// 
	if( m_bRenderFace )
	{
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			glEnableClientState( GL_COLOR_ARRAY );
			glBindBuffer( GL_ARRAY_BUFFER, GetTriangleIdColorVboID() );	// VBO
			glColorPointer( 4, // Must be 4.
				GL_UNSIGNED_BYTE,
				0,
				//m_abt4TriangleIdColor );
				(GLubyte*)0 );
			glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
		}
		else if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );
		}
		else //if( RM_RENDER == eRenderMode )
		{
			glEnable( GL_LIGHTING );	// ̌ʂLɂB

			glEnable( GL_COLOR_MATERIAL );	// ʂ̐Fݒ}eAݒƂB
			glColor3f( 0.5f, 0.5f, 0.0f );

			glEnableClientState( GL_NORMAL_ARRAY ); // @xNgz̗L
			glBindBuffer( GL_ARRAY_BUFFER, m_model.GetTriangleVertexNormalVboID() );	// VBO
			glNormalPointer( GL_FLOAT, 0, 0 );
			glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
		}
		glDrawArrays( GL_TRIANGLES, 0, m_model.m_vIndexedTriangle.size() * 3 );

		glDisableClientState( GL_NORMAL_ARRAY );
		glDisable( GL_COLOR_MATERIAL );
		glDisable( GL_LIGHTING );
		glDisableClientState( GL_COLOR_ARRAY );
		// sbNʂ̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_FACE == m_auiName_picked[1] )
			{
				uiIndexTriangle = m_auiName_picked[2];
				glColor3f( 1.0f, 1.0f, 0.0f );	// sbNF
				glDrawArrays( GL_TRIANGLES, uiIndexTriangle * 3, 3 );
			}
		}
	}
	// 
	if( m_bRenderLine )
	{
		glLineWidth( 2.0 );
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, m_model.GetEdgeVertexIndexVboID() );	// VBO
			for( uiIndexTriangle = 0; uiIndexTriangle < m_model.m_vIndexedTriangle.size(); uiIndexTriangle++ )
			{
				for( ui3 = 0; ui3 < 3; ui3++ )
				{
					uiIndexLine = uiIndexTriangle * 3 + ui3;
					glColor3ub( GetRValue( uiIndexLine ), GetGValue( uiIndexLine ), GetBValue( uiIndexLine ) );
					glDrawElements( GL_LINES,
						2,
						GL_UNSIGNED_INT,
						//&m_model.m_auiEdgeVertexIndex[2 * uiIndexLine] );
						(unsigned int*)( 2 * uiIndexLine * sizeof( unsigned int ) ) );
				}
			}
			glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, 0 );	// oCh̉
		}
		else
		{
			if( RM_PICK_ELEMENTTYPE == eRenderMode )
			{
				glColor3f( 0.0f, 1.0f, 0.0f );
			}
			else // if( RM_RENDER == eRenderMode )
			{
				glColor3f( 0.0f, 0.5f, 0.5f );
			}
			glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, m_model.GetEdgeVertexIndexVboID() );	// VBO
			glDrawElements( GL_LINES,
				m_model.m_vIndexedTriangle.size() * 3 * 2,
				GL_UNSIGNED_INT,
				//&m_model.m_auiEdgeVertexIndex[0] );
				(unsigned int*)0 );
			glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, 0 );	// oCh̉
		}
		// sbN̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_LINE == m_auiName_picked[1] )
			{
				uiIndexLine = m_auiName_picked[2];
				glLineWidth( 5.0f );
				glColor3f( 0.0f, 1.0f, 1.0f );
				glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, m_model.GetEdgeVertexIndexVboID() );	// VBO
				glDrawElements( GL_LINES,
					2,
					GL_UNSIGNED_INT,
					//&m_model.m_auiEdgeVertexIndex[2 * uiIndexLine] );
					(unsigned int*)( 2 * uiIndexLine * sizeof( unsigned int ) ) );
				glBindBuffer( GL_ELEMENT_ARRAY_BUFFER, 0 );	// oCh̉
			}
		}
	}
	// _
	if( m_bRenderPoint )
	{
		glPointSize( 5.0 );
		if( RM_PICK_ELEMENTID == eRenderMode )
		{
			glEnableClientState( GL_COLOR_ARRAY );
			glBindBuffer( GL_ARRAY_BUFFER, GetVertexIdColorVboID() );	// VBO
			glColorPointer( 4, // Must be 4.
				GL_UNSIGNED_BYTE,
				0,
				//m_abt4VertexIdColor );
				(GLubyte*)0 );
			glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
		}
		else if( RM_PICK_ELEMENTTYPE == eRenderMode )
		{
			glColor3f( 0.0f, 0.0f, 1.0f );
		}
		else //if( RM_RENDER == eRenderMode )
		{
			glColor3f( 0.5f, 0.0f, 0.5f );
		}
		glDrawArrays( GL_POINTS, 0, m_model.m_vIndexedTriangle.size() * 3 );
		glDisableClientState( GL_COLOR_ARRAY );
		// sbN_̕`
		if( RM_RENDER == eRenderMode )
		{
			if( RET_POINT == m_auiName_picked[1] )
			{
				uiIndexPoint = m_auiName_picked[2];
				glPointSize( 10.0f );
				glColor3f( 1.0f, 0.0f, 1.0f );
				glDrawArrays( GL_POINTS, uiIndexPoint, 1 );
			}
		}
	}

	// _z̖
	glDisableClientState( GL_VERTEX_ARRAY );

	glPopAttrib();	// Agr[g̕A
	return;
}

void CModelViewerRenderer::IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] )
{
	int  iId_selected = -1;
	unsigned int  uiElementType_selected = RET_FACE + 1;
	long lSquareDist_selected = ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET ) + ( 2 + PICKREGIONOFFSET ) * ( 2 + PICKREGIONOFFSET );
	long lSquareDist_current;
	int  x;
	int  y;
	for( unsigned int ui = 0; ui < uiCountPickRegionPixel; ui++ )
	{
		if( 0 == aauiNamePickRegionPixel[ui][1] )
		{ // f̊O
			continue;
		}

		if( !m_bPickPoint && RET_POINT == aauiNamePickRegionPixel[ui][1] )
		{	// _sbNOFF̏ꍇ́A_̓sbNłȂ
			continue;
		}
		if( !m_bPickLine && RET_LINE == aauiNamePickRegionPixel[ui][1] )
		{	// sbNOFF̏ꍇ́A̓sbNłȂ
			continue;
		}
		if( !m_bPickFace && RET_FACE == aauiNamePickRegionPixel[ui][1] )
		{	// ʃsbNOFF̏ꍇ́Aʂ̓sbNłȂ
			continue;
		}

		if( uiElementType_selected < aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			continue;
		}
		if( uiElementType_selected > aauiNamePickRegionPixel[ui][1] )
		{ // vf^CvIɁAD揇ʂႢ
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
			lSquareDist_selected = x * x + y * y;
			continue;
		}
		// vf^CvIɁAD揇ʂꍇ́AsbN̈̒Sɋ߂̂DxB
		x = ui % ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		y = ui / ( 1 + 2 * PICKREGIONOFFSET ) - PICKREGIONOFFSET;
		lSquareDist_current = x * x + y * y;
		if( lSquareDist_selected > lSquareDist_current )
		{
			iId_selected = ui;
			uiElementType_selected = aauiNamePickRegionPixel[ui][1];
			lSquareDist_selected = lSquareDist_current;
			continue;
		}
	}

	if( -1 == iId_selected )
	{
		return;
	}

	// O񃁃o̍XV
	memcpy( m_auiName_picked, aauiNamePickRegionPixel[iId_selected], NAMEARRAYSIZE * sizeof( unsigned int) );
}

//void CModelViewerRenderer::MakeArray()
void CModelViewerRenderer::MakeVBO()
{
	if( 0 == m_auiVboID[0] )
	{
		glGenBuffers( 3, m_auiVboID );
	}

	unsigned int uiMaxColor = 256 * 256 * 256;	// 256*256*256=16,777,216Bunsigned int ̍ől(4,294,967,295)ɑ΂ė]TB

	// _ԍFz
	unsigned int uiCountData = uiMaxColor * 4;	// P_RGBÂSlB
	GLubyte* abt4VertexIdColor = new GLubyte[uiCountData];
	for( unsigned int ui = 0; ui < uiMaxColor; ui++ )
	{
		abt4VertexIdColor[ui * 4 + 0] = GetRValue( ui );
		abt4VertexIdColor[ui * 4 + 1] = GetGValue( ui );
		abt4VertexIdColor[ui * 4 + 2] = GetBValue( ui );
		abt4VertexIdColor[ui * 4 + 3] = (GLubyte)255;
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetVertexIdColorVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( GLubyte ), abt4VertexIdColor, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete abt4VertexIdColor;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB

	// Op`ԍFz
	uiCountData = uiMaxColor * 3 * 4;	// P̎Op`́ARWlBP_RGBÂSlB
	GLubyte* abt4TriangleIdColor = new GLubyte[uiMaxColor * 3 * 4];
	for( unsigned int ui = 0; ui < uiMaxColor; ui++ )
	{
		GLubyte r = GetRValue( ui );
		GLubyte g = GetGValue( ui );
		GLubyte b = GetBValue( ui );
		abt4TriangleIdColor[ui * 12 + 0] = r;
		abt4TriangleIdColor[ui * 12 + 1] = g;
		abt4TriangleIdColor[ui * 12 + 2] = b;
		abt4TriangleIdColor[ui * 12 + 3] = (GLubyte)255;
		abt4TriangleIdColor[ui * 12 + 4] = r;
		abt4TriangleIdColor[ui * 12 + 5] = g;
		abt4TriangleIdColor[ui * 12 + 6] = b;
		abt4TriangleIdColor[ui * 12 + 7] = (GLubyte)255;
		abt4TriangleIdColor[ui * 12 + 8] = r;
		abt4TriangleIdColor[ui * 12 + 9] = g;
		abt4TriangleIdColor[ui * 12 + 10] = b;
		abt4TriangleIdColor[ui * 12 + 11] = (GLubyte)255;
	}
	glBindBuffer( GL_ARRAY_BUFFER, GetTriangleIdColorVboID() );
	glBufferData( GL_ARRAY_BUFFER, uiCountData * sizeof( GLubyte ), abt4TriangleIdColor, GL_STATIC_DRAW );
	glBindBuffer( GL_ARRAY_BUFFER, 0 );	// oCh̉
	delete abt4TriangleIdColor;	// VRAMɓ]f[^glBufferDataɂāAVRAMɃf[^uBRAMɃf[^͕svB
}

//void CModelViewerRenderer::DestroyArray()
void CModelViewerRenderer::DestroyVBO()
{
	if( 0 == m_auiVboID[0] )
	{
		return;
	}

	glDeleteBuffers( 3, m_auiVboID );
	memset( m_auiVboID, 0x00, 3 * sizeof( unsigned int ) );
}

bool CModelViewerRenderer::InitializeOpenGL( HWND hWnd )
{
	if( !COpenGLRendererPick::InitializeOpenGL( hWnd ) )
	{
		return false;
	}

	MakeVBO();

	return true;
}

void CModelViewerRenderer::UninitializeOpenGL( HWND hWnd )
{
	m_model.DestroyVBO();
	DestroyVBO();

	COpenGLRendererPick::UninitializeOpenGL( hWnd );
}
